/**
 * MCItem: experimental
 * @version 0.1
 * @author Alexandre David
 */

package adavid.awt;

import java.awt.*;
import java.awt.event.*;

/**
 * MCItem multi column item
 * imported from Alex.awt : unfinished ; pre-beta version in progress
 */
public class MCItem extends Panel {

  Color focusColor=TNode.DEFAULT_SELECTED_COLOR;
  boolean valid=false,hasFocus=false;
  Dimension size=new Dimension();

  public MCItem() {
    setLayout(null);
    enableEvents(AWTEvent.FOCUS_EVENT_MASK);
  }

  public MCItem(String item) {
    this();
    addItem(item);
  }

  public Component add(Component compo) {
    if (compo!=null) {
      valid=false;
      return super.add(compo);
    }
    else
      return null;
  }

  public void addItem(Object item) {
    add(new Label(item.toString()));
  }

  public void setFont(Font font) {
    if (font!=null) {
      int n=getComponentCount();
      while(--n>=0)
	getComponent(n).setFont(font);
    }
  }

  public boolean isFocusTraversable() {
    return true;
  }

  public void removeNotify() {
    hasFocus=false;
    super.removeNotify();
  }

  protected void processFocusEvent(FocusEvent e) {
    hasFocus=(e.getID()==FocusEvent.FOCUS_GAINED);
    Graphics g=getGraphics();
    if (g!=null) {
      Dimension dim=getSize();
      Color color=g.getColor();
      g.setColor(hasFocus?Color.black:getBackground());
      g.drawRect(0,0,dim.width-1,dim.height-1);
      g.setColor(color);
    }
  }

  public Dimension getPreferredSize() {
    if (!valid) {
      Component[] compo=getComponents();
      int w=0,h=0;
      for(int i=0;i<compo.length;i++) {
	int width,height;
	Component c=compo[i];
	if (c.getFont()!=null && c instanceof Label) {
	  String text=((Label)c).getText();
	  FontMetrics fm=getToolkit().getFontMetrics(c.getFont());
	  width=fm.stringWidth(text+' ');
	  height=fm.getHeight()+2;
	}
	else {
	  Dimension dim=c.getPreferredSize();
	  width=dim.width;
	  height=dim.height;
	}
	c.setBounds(w,0,width,height);
	w+=width;
	if (h<height)
	  h=height;
      }
      size.width=w;
      size.height=h;
      valid=true;
    }
    return new Dimension(size);
  }

  public void paint(Graphics g) {
    super.paint(g);
    if (hasFocus) {
      Dimension dim=getSize();
      Color color=g.getColor();
      g.setColor(Color.black);
      g.drawRect(0,0,dim.width-1,dim.height-1);
      g.setColor(color);
    }
  }

}
