/**
 * TListner: the listener of a simple event, not
 * really in fact, originated by MouseEvent when
 * clicking on a tree node.
 * @version 1.0
 * @author Alexandre David
 */
package adavid.awt;

/**
 * the listener interface for TNode
 */
public interface TListener {

    /**
     * called when double click occurs on a node
     * @param node the node which received the event
     */
    public void nodeDoubleClicked(TNode node);

    /**
     * called when a simple click occurs on a node, note
     * that the second click, if counted as double click
     * does not call this method.
     * @param node the node which received the event
     */
    public void nodeClicked(TNode node);

}
