/**
 * TNodeRenderer: interface used to draw
 * the handle and any icon of a tree node
 * @version 1.0
 * @author Alexandre David
 */

package adavid.awt;

import java.awt.Graphics;

public interface TNodeRenderer {

  /**
   * called by TNode.paint(Graphics) when the tree node
   * needs to be repainted.
   * @param node the node to be repainted
   * @param g Graphics object to repaint the node
   * @param expanded state of the node
   * @param selected state of the node
   * @param leaf nature of the node
   */
  public void paint(TNode node,Graphics g,boolean expanded,boolean selected,boolean leaf);

  /**
   * @return the height of the painted zone, icon or whatever,
   * not the whole tree node!
   */
  public int getHeight();

  /**
   * @return the width of the painted zone, icon or whatever,
   * not the whole tree node!
   */
  public int getWidth();

}
