/**
 * SortableClass
 * a wrapper to sort classes
 * @version 1.0
 * @author Alexandre David
 */

/**
 * version history
 * 1.0: first version
 */

package adavid.reflect;

import adavid.util.*;
import java.lang.reflect.*;

/**
 * SortableClass
 * wraps a class so that it can easily sorted
 */
public class SortableClass extends ObjectString {

  /**
   * constructors
   */
  public SortableClass(Class theClass) {
    super(theClass);
  }
  //not public because it the sort string has a meaning: it is not whatsoever!
  SortableClass(Class theClass,String sortString) {
    super(theClass,sortString,ClassReflect.getModifiers(theClass).append(sortString).toString());
  }

  /**
   * returns the typed object
   * cast exception if setObject was used with a bad object
   */
  public Class getTheClass() {
    return (Class)getObject();
  }

}
