/**
 * SortableField
 * a wrapper for fields so that they can be
 * sorted.
 * @version 1.0
 * @author Alexandre David
 */

/**
 * version history:
 * 1.0: first version
 */

package adavid.reflect;

import adavid.util.*;
import java.lang.reflect.*;

/**
 * SortableField
 * to sort fields: by type and name
 *
 *
 * same principle as ObjectString, may return
 * the Field as well (by a cast)
 */
public class SortableField extends ObjectString {

  /**
   * constructors
   */
  public SortableField(Field field) {
    super(field);
  }
  //not public because the sort string has a meaning: it is not whatsoever!
  SortableField(Field field,String sortString) {
    super(field,sortString,ClassReflect.getModifiers(field).append(sortString).toString());
  }

  /**
   * returns the typed object
   * cast error if setObject used with a bad object
   */
  public Field getField() {
    return (Field)getObject();
  }

}
