/**
 * LTreeContent
 * An interface which gives abstraction on the
 * content of the node of a tree. The content
 * should be able to return different icon
 * representations depending on its state for example.
 * @version 1.1
 * @author Alexandre David
 */

/**
 * version history:
 * 1.0: first version
 * 1.1 990829: use swing 1.1.1
 */

package adavid.swing;

import javax.swing.Icon;

/**
 * content type for LNodeTree
 */
public interface LTreeContent {

  public String getText();
  public Icon getIcon(boolean isExpanded,boolean isLeaf,boolean isSelected);
  public String getToolTip();
  public String toString();

}
