/**
 * LTreeContrentAdapter
 * This is a default implementation of LTreeContent
 * @version 1.1
 * @author Alexandre David
 */

/**
 * version history:
 * 1.0: first version
 * 1.1 990829: use swing 1.1.1
 */

package adavid.swing;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import adavid.util.JResource;

/**
 * adapter for the content of a LTreeNode
 */
public class LTreeContentAdapter implements LTreeContent {
  
  /**
   * the path of the icons
   */
  public static String path$icons="adavid/icons/";

  /**
   * the icons themselves ; note that they are the same
   * in adavid.awt.ImageTNodeRenderer ; the difference is
   * that here we have Icon (which are ImageIcon in fact)
   * see ImageTNodeRenderer for comments on the weak programming
   * model
   */
  public static Icon TreeLeaf,TreeLeafSelected;
  public static Icon TreeNode,TreeSelected;
  public static Icon TreeOpen,TreeOpenSelected;

  /**
   * initialize the icons
   */
  static {
    new JResource(new LTreeContentAdapter());
    //System.out.println("JResource was used");
  }

  /**
   * returns the icon to be displayed by a cell
   */
  public Icon getIcon(boolean isExpanded,boolean isLeaf,boolean isSelected) {
    if (isLeaf) {
      if (isSelected)
	return TreeLeafSelected;
      else
	return TreeLeaf;
    }
    else if (isExpanded) {
      if (isSelected)
	return TreeOpenSelected;
      else
	return TreeOpen;
    }
    else {
      if (isSelected)
	return TreeSelected;
      else
	return TreeNode;
    } 
  }

  /**
   * default value
   */
  public String getToolTip() {
    return getText();
  }

  /**
   * implemented just to get an instance of this class for the resources
   */
  public String getText() {
    return toString();
  }
}
