/**
 * Interval
 * a single class with a start and an end position
 * to represent an interval or a substring
 * @version 1.0
 * @author Alexandre David
 */

/**
 * version history
 * 1.0: first version
 */

package adavid.util;

import java.io.Serializable;

public class Interval implements Cloneable,Serializable {

  int start,end;

  /**
   * constructor for errors
   */
  public Interval() {
    start=-1;
    end=-1;
  }

  /**
   * constructor: takes the limits of the interval
   */
  public Interval(int start,int end) {
    this.start=start;
    this.end=end;
  }

  /**
   * returns the start
   */
  public int getStart() {
    return start;
  }

  /**
   * returns the end
   */
  public int getEnd() {
    return end;
  }

  /**
   * returns the substring corresponding to
   * the interval ; safe checks are performed
   */
  public String substring(String string) {
    if (string==null)
      return null;
    int len=string.length();
    if (start<0 || start>=end || end>len)
      return null;
    else
      return string.substring(start,end);
  }

}
